明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1245|回复: 2

[已解决]vba如何实现相对一点的角度和长度绘制线?

[复制链接]
发表于 2008-7-16 10:12:00 | 显示全部楼层 |阅读模式
本帖最后由 作者 于 2008-7-16 15:44:25 编辑

如下命令如何使用vba的代码实现?
  1. 命令: line
  2. 指定第一点: 100,100
  3. 指定下一点或 [放弃(U)]: @150<90
复制代码
发表于 2008-7-16 11:48:00 | 显示全部楼层

使用PolarPoint 方法

获取与给定点指定角度和距离的点。

MSITStore:D:\acadauto(明经通道翻译的autocad%20vba帮助).chm::/polarpoint_see_also.htm">参阅 | MSITStore:D:\acadauto(明经通道翻译的autocad%20vba帮助).chm::/ex_polarpoint.htm">示例

语法

RetVal = PolarPoint(Point, Angle, Distance)

Object

MSITStore:D:\acadauto(明经通道翻译的autocad%20vba帮助).chm::/idh_utility_object.htm">Utility
使用该方法的对象。

Point

Variant[变体] (三元素双精度数组); 仅用于输入
指定起点的三维WCS坐标。

Angle

Double[双精度]; 仅用于输入
以弧度为单位的角度值。

Distance

Double[双精度]; 仅用于输入
以当前单位为单位的距离值。

RetVal

Variant[变体] (三元素双精度数组)
该三维WCS的坐标是根据相对给出点的距离和角度得到的坐标。

Sub Example_PolarPoint()
    ' This example finds the coordinate of a point that is a given
    ' distance and angle from a base point.
    
    Dim polarPnt As Variant
    Dim basePnt(0 To 2) As Double
    Dim angle As Double
    Dim distance As Double
    
    basePnt(0) = 2#: basePnt(1) = 2#: basePnt(2) = 0#
    angle = 0.1744444   ' 45 degrees
    distance = 5
    polarPnt = ThisDrawing.Utility.PolarPoint(basePnt, angle, distance)
    
    ' Create a line from the base point to the polar point
    Dim lineObj As AcadLine
    Set lineObj = ThisDrawing.ModelSpace.AddLine(basePnt, polarPnt)
    ZoomAll
    
End Sub
 楼主| 发表于 2008-7-16 15:43:00 | 显示全部楼层
谢谢了!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 08:16 , Processed in 0.158274 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表